org.codehaus.plexus.compiler

## Class AbstractCompiler

- java.lang.Object
- - org.codehaus.plexus.logging.AbstractLogEnabled
  - - org.codehaus.plexus.compiler.AbstractCompiler

All Implemented Interfaces:
  Compiler, org.codehaus.plexus.logging.LogEnabled

Direct Known Subclasses:
  CSharpCompiler, EclipseJavaCompiler, JavacCompiler, JikesCompiler

    public abstract class AbstractCompiler
    extends org.codehaus.plexus.logging.AbstractLogEnabled
    implements Compiler

Version:
  $Id$
Author:
  Jason van Zyl , Michal Maczka , Trygve Laugstøl

### Field Summary

Fields
`protected static String` `EOL`
`protected static String` `PS`

### Fields inherited from interface org.codehaus.plexus.compiler.Compiler

`ROLE`

### Constructor Summary

Constructors
`protected` `AbstractCompiler(CompilerOutputStyle compilerOutputStyle, String inputFileEnding, String outputFileEnding, String outputFile)`

### Method Summary

Methods
`boolean` `canUpdateTarget(CompilerConfiguration configuration)`
`CompilerOutputStyle` `getCompilerOutputStyle()`
`String` `getInputFileEnding(CompilerConfiguration configuration)`
`String` `getOutputFile(CompilerConfiguration configuration)`
`String` `getOutputFileEnding(CompilerConfiguration configuration)`
`static String` `getPathString(List<String> pathElements)`
`protected static String[]` `getSourceFiles(CompilerConfiguration config)`
`protected static Set<String>` `getSourceFilesForSourceRoot(CompilerConfiguration config, String sourceLocation)`
`protected static String` `makeClassName(String fileName, String sourceDir)`
`protected static String[]` `toStringArray(List<String> arguments)` Deprecated. use (String[]) arguments.toArray( new String[ arguments.size() ] ); instead

### Methods inherited from class org.codehaus.plexus.logging.AbstractLogEnabled

`enableLogging, getLogger, setupLogger, setupLogger, setupLogger`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.codehaus.plexus.compiler.Compiler

`compile, createCommandLine`

### Field Detail

#### EOL

    protected static final String EOL

#### PS

    protected static final String PS

### Constructor Detail

#### AbstractCompiler

    protected AbstractCompiler(CompilerOutputStyle compilerOutputStyle,
                    String inputFileEnding,
                    String outputFileEnding,
                    String outputFile)

### Method Detail

#### getCompilerOutputStyle

    public CompilerOutputStyle getCompilerOutputStyle()

Specified by:
  `getCompilerOutputStyle` in interface `Compiler`

#### getInputFileEnding

    public String getInputFileEnding(CompilerConfiguration configuration)
                              throws CompilerException

Specified by:
  `getInputFileEnding` in interface `Compiler`
Throws:
  `CompilerException`

#### getOutputFileEnding

    public String getOutputFileEnding(CompilerConfiguration configuration)
                               throws CompilerException

Specified by:
  `getOutputFileEnding` in interface `Compiler`
Throws:
  `CompilerException`

#### getOutputFile

    public String getOutputFile(CompilerConfiguration configuration)
                         throws CompilerException

Specified by:
  `getOutputFile` in interface `Compiler`
Throws:
  `CompilerException`

#### canUpdateTarget

    public boolean canUpdateTarget(CompilerConfiguration configuration)
                            throws CompilerException

Specified by:
  `canUpdateTarget` in interface `Compiler`
Throws:
  `CompilerException`

#### getPathString

    public static String getPathString(List<String> pathElements)

#### getSourceFilesForSourceRoot

    protected static Set<String> getSourceFilesForSourceRoot(CompilerConfiguration config,
                                          String sourceLocation)

#### getSourceFiles

    protected static String[] getSourceFiles(CompilerConfiguration config)

#### makeClassName

    protected static String makeClassName(String fileName,
                       String sourceDir)
                                   throws CompilerException

Throws:
  `CompilerException`

#### toStringArray

    protected static String[] toStringArray(List<String> arguments)

Deprecated. use (String[]) arguments.toArray( new String[ arguments.size() ] ); instead